﻿Imports System.Net
Imports System.Web.Http
Imports System.Net.Http

Public Class ProdutosController
    Inherits ApiController

    Shared ReadOnly repositorio As IProdutoRepositorio = New ProdutoRepositorio()

    Public Function GetAllProducts() As IEnumerable(Of Produto)
        Return repositorio.GetTodos()
    End Function

    Public Function GetProduto(id As Integer) As Produto
        Dim item As Produto = repositorio.GetPorID(id)
        If item Is Nothing Then
            Throw New HttpResponseException(New HttpResponseMessage(HttpStatusCode.NotFound))
        End If
        Return item
    End Function

    Public Function GetProdutosPorCategoria(categoria As String) As IEnumerable(Of Produto)
        Return repositorio.GetTodos().Where(Function(p) String.Equals(p.Categoria, categoria, StringComparison.OrdinalIgnoreCase))
    End Function

    Public Function PostProduto(item As Produto) As HttpResponseMessage
        item = repositorio.Adicionar(item)
        Dim response = Request.CreateResponse(Of Produto)(HttpStatusCode.Created, item)

        Dim uri As String = Url.Link("DefaultApi", New With { _
            .id = item.Id _
        })
        response.Headers.Location = New Uri(uri)
        Return response
    End Function

    Public Sub PutProduto(id As Integer, produto As Produto)
        produto.Id = id
        If Not repositorio.Atualizar(produto) Then
            Throw New HttpResponseException(New HttpResponseMessage(HttpStatusCode.NotFound))
        End If
    End Sub

    Public Function DeletaProduto(id As Integer) As HttpResponseMessage
        repositorio.Remover(id)
        Return New HttpResponseMessage(HttpStatusCode.NoContent)
    End Function

End Class
