﻿Public Class ProdutoRepositorio
    Implements IProdutoRepositorio

    Private produtos As New List(Of Produto)()
    Private _proximoId As Integer = 1

    Public Sub New()
        Adicionar(New Produto() With { _
         .Id = 1, .Nome = "Caneta", .Categoria = "Papelaria", .Preco = 1.39D _
        })
        Adicionar(New Produto() With { _
         .Id = 2, .Nome = "Table Ipad", .Categoria = "Informática", .Preco = 993.75D _
        })
        Adicionar(New Produto() With { _
         .Id = 3, .Nome = "NoteBook CCE", .Categoria = "Informática", .Preco = 1016.99D _
        })
    End Sub

    Public Function Adicionar(item As Produto) As Produto Implements IProdutoRepositorio.Adicionar
        'item.Id = System.Math.Max(System.Threading.Interlocked.Increment(_proximoId), _proximoId - 1)
        item.Id = _proximoId + 1
        produtos.Add(item)
        Return item
    End Function

    Public Function Atualizar(item As Produto) As Boolean Implements IProdutoRepositorio.Atualizar
        Dim index As Integer = produtos.FindIndex(Function(p) p.Id = item.Id)
        If index = -1 Then
            Return False
        End If
        produtos.RemoveAt(index)
        produtos.Add(item)
        Return True
    End Function

    Public Function GetPorID(id As Integer) As Produto Implements IProdutoRepositorio.GetPorID
        Return produtos.Find(Function(p) p.Id = id)
    End Function

    Public Function GetTodos() As System.Collections.Generic.IEnumerable(Of Produto) Implements IProdutoRepositorio.GetTodos
        Return produtos
    End Function

    Public Sub Remover(id As Integer) Implements IProdutoRepositorio.Remover
        produtos.RemoveAll(Function(p) p.Id = id)
    End Sub
End Class
